
from Products.Localizer.Accept import AcceptLanguage
import Products.Localizer.Accept

# from Products.Silva.SilvaObject import SilvaObject

import zLOG

# disable the accept_language http-header parsing;
# should only use accept_path for better behaviour with caches

class AcceptLanguageDummy:

    __allow_access_to_unprotected_subobjects__ = 1

    def __init__(self, language):
        self.lang = None
        self.quality = 0.0
    
    def select_language(self, languages):        
        return self.lang

    
    def __setitem__(self, lang, quality):
        if quality > self.quality:
            self.lang = lang
            self.quality = quality

    set = __setitem__

Products.Localizer.Accept.AcceptLanguage = AcceptLanguageDummy
Products.Localizer.AcceptLanguage = AcceptLanguageDummy

zLOG.LOG('SilvaLocalContent',-100,'monkey patched Localizer to ignore http-headers')


# patch an implements_localobject to the silva object
# XXX: not yet; partially YAGNI, partiall because it is not useful anyway
# as all objects in a LocalRoot will implement it, and none in a plain Root (?)
#def SilvaObject_implements_localobject(self):
#    return ILocalSilvaObject.isImplementedBy(self)
#
#SilvaObject.implements_localobject = SilvaObject_implements_localobject
#SilvaObject.security.declareProtected('implements_localobject',...)

#
# ugly patch to the "Security" class to get rid of
# hard boiled meta type for root
# should not be necessary for Silva 0.9.x, x>2 and should be disabled then
#

from Products.Silva.IRoot import IRoot

def Security_sec_get_nearest_of_role(self, role):
    """Get a list of userids that have a role in this context. This
    goes up the tree and finds the nearest user(s) that can be found.
    """
    obj = self.aq_inner
    while 1:
        # get all users defined on this object
        userids = obj.sec_get_userids()
        if userids:
            result = []
            for userid in userids:
                if role in obj.sec_get_roles_for_userid(userid):
                    result.append(userid)
            if result:
                return result
                
        # ONLY THIS LINE CHANGED: 
        if IRoot.isImplementedBy(obj):
            break
        obj = obj.aq_parent
    return []

# original code says: "deprecated, use 'sec_is_closed_to_public' instead"
def Security_sec_is_open_to_public(self):
        """Check whether this is opened.
        """
        # XXX ugh
        while 1:
            for role_info in self.rolesOfPermission('View'):
                if (role_info['name'] == 'Viewer' and
                    role_info['selected'] == 'SELECTED'):
                    return 0
            # we know now that on this particular object ther viewer role is not set as a minimum,
            # but need to also know if that behaviour isn't acquired at this point. So let's walk through
            # all parents
            # ONLY THIS LINE CHANGED: 
            if IRoot.isImplementedBy(self):
                return 1
            self = self.aq_parent

def Security_sec_is_closed_to_public(self):
        """Check whether this is closed. This method returns 0 if the object 
        is open to public, 1 if the object itself is set to closed and a 
        1+<number of parents up> if the some parent object is closed (so if 
        the effect is acquired).
        """
        # XXX ugh
        i = 0
        curobj = self
        while 1:
            i += 1
            rop = curobj.rolesOfPermission('View')
            if {'selected': 'SELECTED', 'name': 'Viewer'} in rop and not {'selected': 'SELECTED', 'name': 'Anonymous'} in rop:
                return i
            # we know now that on this particular object ther viewer role is not set as a minimum,
            # but need to also know if that behaviour isn't acquired at this point. So let's walk through
            # all parents
            # ONLY THIS LINE CHANGED: 
            if IRoot.isImplementedBy(curobj):
                return 0
            curobj = curobj.aq_parent


from Products.Silva.Security import Security
Security.sec_get_nearest_of_role = Security_sec_get_nearest_of_role
Security.sec_is_closed_to_public = Security_sec_is_closed_to_public
Security.sec_is_open_to_public   = Security_sec_is_open_to_public
